package com.qmth.test.image;

import org.apache.commons.io.FileUtils;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ImageConvert {

    public static File source;

    public static File blank;

    public static int[] count;

    public static Map<String, File> map;

    public static Pattern pattern = Pattern.compile("(\\d+)-(\\d+).jpg");

    public static void main(String[] args) throws IOException {
        source = new File(args[0]);
        blank = new File(args[1]);
        count = config(args[2]);
        source = new File("/Users/luoshi/test/image-convert/ft-sheet");
        //blank = new File("/Users/luoshi/Downloads/cs/kby.jpg");
        count = config("2,2,2,2");
        map = new HashMap<String, File>();

        loop(source);
        if (blank != null) {
            check();
        }
    }

    private static int[] config(String input) {
        String[] values = input.split(",");
        int[] array = new int[values.length];
        for (int i = 0; i < array.length; i++) {
            array[i] = Integer.parseInt(values[i]);
        }
        return array;
    }

    private static int getPage(int mainPage, int subPage) {
        int page = 0;
        for (int i = 0; i < (mainPage - 1); i++) {
            page += count[i];
        }
        page += subPage;
        return page;
    }

    private static int getTotalPage() {
        int page = 0;
        for (int i = 0; i < count.length; i++) {
            page += count[i];
        }
        return page;
    }

    private static void check() throws IOException {
        int totalPage = getTotalPage();
        for (java.util.Map.Entry<String, File> entry : map.entrySet()) {
            String examNumber = entry.getKey();
            File dir = entry.getValue();

            for (int i = 1; i <= totalPage; i++) {
                File file = new File(dir, examNumber + "-" + i + ".jpg");
                if (!file.exists()) {
                    FileUtils.copyFile(blank, file);
                    System.out.println("copy blank -> " + file);
                }
            }
        }
    }

    private static void loop(File dir) throws IOException {
        for (File file : dir.listFiles()) {
            if (file.isDirectory()) {
                loop(file);
            } else {
                process(file);
            }
        }
    }

    private static void process(File file) throws IOException {
        String name = file.getName();
        Matcher m = pattern.matcher(name);
        if (m.matches()) {
            String barcode = m.group(1);
            String examNumber = barcode.substring(0, barcode.length() - 1);
            int index1 = Integer.parseInt(barcode.substring(barcode.length() - 1));
            int index2 = Integer.parseInt(m.group(2));

            String newName = examNumber + "-" + getPage(index1, index2) + ".jpg";
            System.out.println(name + " -> " + newName);

            File newFile = new File(file.getParentFile().getAbsolutePath().replaceAll("ft", "ft-new"), newName);
            newFile.getParentFile().mkdirs();
            FileUtils.copyFile(file, newFile);

            map.put(examNumber, newFile.getParentFile());
        }
    }

}
