package com.qmth.test.image;

import com.qmth.test.image.utils.Coordinate;
import com.qmth.test.image.utils.CropUtil;
import com.qmth.test.image.utils.Student;
import org.apache.commons.lang.StringUtils;

import java.io.*;
import java.util.*;

public class ImageCrop {

    public static Properties config = new Properties();

    //public static Pattern pattern = Pattern.compile("(\\d+)-(\\d+).jpg");

    public static Map<String, Student> studentMap = new HashMap<String, Student>();

    public static List<Coordinate> coordinateList = new LinkedList<Coordinate>();

    public static void main(String[] args) throws IOException {
        //config.load(ImageCrop.class.getClassLoader().getResourceAsStream("crop.properties"));
        config.load(new FileInputStream(args[0]));
        loadStudent(config.getProperty("student.file"));
        loadCoordinate(config.getProperty("coordinate"));
        startCrop(config.getProperty("sheet.path"), config.getProperty("slice.path"));
    }

    private static void loadCoordinate(String config) {
        String[] values = StringUtils.split(config, ",");
        for (String value : values) {
            Coordinate c = new Coordinate(StringUtils.split(value, ":"));
            coordinateList.add(c);
        }
    }

    private static void loadStudent(String file) throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(file));
        String line = null;
        while ((line = reader.readLine()) != null) {
            String[] values = StringUtils.split(line, "\t");
            Student s = new Student();
            s.examId = values[0];
            s.campusId = values[1];
            s.subjectCode = values[2];
            s.examNumber = values[3];
            studentMap.put(s.examNumber, s);
        }
        reader.close();
    }

    private static void startCrop(String sheetPath, String slicePath) throws IOException {
        int count = 0;
        for (Student s : studentMap.values()) {
            cropStudent(s, sheetPath, slicePath);
            count++;
        }
        System.out.println(count + " student crop finish");
    }

    public static void cropStudent(Student s, String sheetRoot, String sliceRoot) throws IOException {
        for (Coordinate c : coordinateList) {
            File sheetFile = new File(new File(new File(sheetRoot, s.examId + "-" + s.campusId), s.subjectCode),
                    s.examNumber + "-" + c.sheet + ".jpg");
            File sliceFile = new File(new File(new File(sliceRoot, s.examId + "-" + s.campusId), s.subjectCode),
                    s.examNumber + "-" + c.slice + ".jpg");
            sliceFile.getParentFile().mkdirs();
            CropUtil.cutImage(sheetFile, sliceFile, c.x, c.y, c.w, c.h);
            System.out.println(sheetFile.getAbsolutePath() + " -> " + sliceFile.getAbsolutePath());
        }
    }

}
