package com.qmth.test.image;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Properties;

import org.apache.commons.httpclient.HttpException;
import org.apache.commons.lang3.StringUtils;

import com.qmth.test.image.utils.GxStudentApiClient;

import main.java.com.UpYun;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

/**
 * Hello world!
 *
 */
public class ImageDownload {

    private static Properties config = new Properties();

    private static UpYun upyun;

    private static File base;

    private static int picCount;

    private static GxStudentApiClient client;

    private static BufferedWriter logger;

    public static void main(String[] args) throws NumberFormatException, HttpException, IOException {
        config.load(new FileInputStream(args[0]));
        upyun = new UpYun(config.getProperty("upyun.bucket"), config.getProperty("upyun.username", "qmth-picture"),
                config.getProperty("upyun.password", "qmth12345678"));
        base = new File(config.getProperty("output.dir"));
        client = new GxStudentApiClient(config.getProperty("server.host"), config.getProperty("server.username"),
                config.getProperty("server.password"));
        picCount = Integer.valueOf(config.getProperty("pic.count"));
        try {
            logger = new BufferedWriter(new FileWriter(config.getProperty("log.file")));
        } catch (Exception e) {
            logger = null;
        }
        String[] ids = StringUtils.split(config.getProperty("exam.ids"), ",");
        for (String value : ids) {
            int examId = 0;
            try {
                examId = Integer.valueOf(value);
            } catch (Exception e) {
            }
            if (examId > 0) {
                log("process examId: " + examId);
                getStudent(examId, 1000);
            } else {
                log("Invalid examId: " + value);
            }
        }

        if (logger != null) {
            try {
                logger.close();
            } catch (Exception e) {
                logger = null;
            }
        }
    }

    private static void getStudent(int examId, int pageSize) throws HttpException, IOException {
        int pageNumber = 1;
        JSONArray array = client.list(examId, true, null, pageNumber, pageSize);
        while (array != null && !array.isEmpty()) {
            for (int i = 0; i < array.size(); i++) {
                download(examId, array.getJSONObject(i));
            }
            pageNumber++;
            array = client.list(examId, true, null, pageNumber, pageSize);
        }
    }

    private static void download(int examId, JSONObject student) {
        File dir = new File(new File(base, examId + "-" + student.getString("campusCode")),
                student.getString("subjectCode"));
        dir.mkdirs();
        for (int i = 1; i <= picCount; i++) {
            download(examId, student, dir, i);
        }
    }

    private static void download(int examId, JSONObject student, File dir, int index) {
        String path = "/" + examId + "-" + student.getString("campusCode") + "/" + student.getString("subjectCode")
                + "/" + student.getString("examNumber") + "-" + index + ".jpg";

        File dest = new File(dir, student.getString("examNumber") + "-" + index + ".jpg");
        if (dest.exists() && dest.isFile() && dest.length() > 0) {
            log(path + ": exist");
            return;
        }
        int retry = 1;
        while (retry <= 3) {
            boolean success = false;
            try {
                success = upyun.readFile(path, dest);
            } catch (Exception e) {
            }
            if (success == true) {
                log(path + ": success");
                return;
            } else {
                retry++;
            }
        }
        log(path + ": faile");
    }

    private static void log(String message) {
        System.out.println(message);
        if (logger != null) {
            try {
                logger.write(message);
                logger.newLine();
            } catch (Exception e) {
            }
        }
    }

}
