package com.qmth.test.image;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import org.apache.commons.httpclient.HttpException;

import main.java.com.UpYun;

/**
 * Hello world!
 *
 */
public class ImageDownloadFromFile {

    protected static UpYun sheet = new UpYun("gx-sheet", "qmth-picture", "qmth12345678");

    protected static UpYun slice = new UpYun("gx-slice", "qmth-picture", "qmth12345678");

    protected static File input;

    protected static File output;

    public static void main(String[] args) throws NumberFormatException, HttpException, IOException {
        input = new File(args[0]);
        if (!input.exists() || !input.isFile()) {
            System.out.println("考生数据文件不存在");
            return;
        }
        output = new File(args[1]);
        if (!output.exists() || !output.isDirectory()) {
            System.out.println("图片输出目录不存在");
            return;
        }
        BufferedReader reader = new BufferedReader(new FileReader(input));
        String line = null;
        int count = 0;
        int download = 0;
        while ((line = reader.readLine()) != null) {
            if (count % 5000 == 0) {
                System.out.println("完成处理考生：" + count);
            }
            count++;
            boolean success = true;
            String[] values = line.split("\t");
            success = download(sheet, "gx-sheet", values[0], values[1], values[2], values[3],
                    Integer.valueOf(values[4])) & success;
            success = download(slice, "gx-slice", values[0], values[1], values[2], values[3],
                    Integer.valueOf(values[5])) & success;
            if (success) {
                download++;
            }
        }
        System.out.println("完成处理考生：" + count);
        System.out.println("成功下载考生：" + download);
        reader.close();
    }

    private static boolean download(UpYun upyun, String prefix, String examId, String campusId, String examNumber,
            String subjectCode, int count) {
        boolean success = true;
        for (int i = 1; i <= count; i++) {
            String path = "/" + examId + "-" + campusId + "/" + subjectCode + "/" + examNumber + "-" + i + ".jpg";
            File file = new File(new File(new File(new File(output, prefix), examId + "-" + campusId), subjectCode),
                    examNumber + "-" + i + ".jpg");
            if (file.exists() && file.length() > 0) {
                continue;
            } else {
                success = download(upyun, path, file) & success;
            }
        }
        return success;
    }

    private static boolean download(UpYun upyun, String path, File file) {
        file.getParentFile().mkdirs();
        int retry = 1;
        while (retry <= 3) {
            boolean success = false;
            try {
                success = upyun.readFile(path, file);
            } catch (Exception e) {
            }
            if (success == true) {
                return true;
            } else {
                retry++;
            }
        }
        return false;
    }
}
