package com.qmth.test.image.model;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;

public class Student {

    public static DecimalFormat format;

    public int id;

    public int examId;

    public String subjectCode;

    public int campusId;

    public String examNumber;

    public int sheetCount;

    public int sliceCount;

    public double score;

    public String scoreDetail;

    public List<Double> scoreList;

    public List<Integer> groups;

    public List<Question> questions;

    public Map<Integer, String> markerName;

    public String secretNumber;

    public List<Double> getScoreList() {
        List<Double> list = new ArrayList<>();
        String[] values = StringUtils.split(scoreDetail, ";");
        for (String value : values) {
            try {
                double s = Double.parseDouble(value);
                list.add(s);
            } catch (Exception e) {
                continue;
            }
        }
        return list;
    }

    public String buildGroupScoreDetail() {
        Map<Integer, List<Double>> map = new HashMap<>();
        int i = -1;
        for (Question q : questions) {
            i++;
            if (scoreList.size() > i) {
                map.computeIfAbsent(q.groupNumber, groupNumber -> new ArrayList<>()).add(scoreList.get(i));
            }
        }
        StringBuilder content = new StringBuilder();
        for (Integer groupNumber : groups) {
            List<Double> score = map.get(groupNumber);
            if (score != null) {
                if (content.length() > 0) {
                    content.append("+");
                }
                content.append(format.format(score.stream().mapToDouble(s -> s).sum()));
                // content.append(score.stream().map(s ->
                // format.format(s)).collect(Collectors.joining("+", "(",
                // ")")));
            }
        }
        return content.toString();
    }

}
