package com.qmth.test.image.utils;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.regex.Pattern;

import javax.imageio.ImageIO;

public class CoverUtil {

    public static void coverImage(File src, File dest, int x, int y, int w, int h) throws IOException {
        try {
            BufferedImage image = ImageIO.read(src);
            Graphics2D g2d = image.createGraphics();
            // 设置白色矩形框
            g2d.setColor(Color.WHITE);
            g2d.fillRect(x, y, w, h);
            ImageIO.write(image, "jpg", dest);
            g2d.dispose();
        } catch (Exception e) {
            throw new RuntimeException(src + ":" + x + "," + y + "," + w + "," + h + " crop error", e);
        }

    }

    public static void main(String[] args) throws IOException {
        Pattern pattern = Pattern.compile("(\\d+).jpg");
        File input = new File("/Users/yin/Downloads/static/823");
        File output = new File("/Users/yin/Downloads/static");

        for (File file : input.listFiles()) {
            if (file.isFile()) {
                    coverImage(file, new File(output,   "111.jpg"), 1, 1, 1000, 2000);
            }
        }
    }

}
