package com.qmth.test.image.utils;

import javax.imageio.ImageIO;
import javax.imageio.ImageReadParam;
import javax.imageio.ImageReader;
import javax.imageio.stream.ImageInputStream;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class CropUtil {

    public static void cutImage(File src, File dest, int x, int y, int w, int h) throws IOException {
        Iterator<ImageReader> iterator = ImageIO.getImageReadersByFormatName("jpg");
        ImageReader reader = iterator.next();

        ImageInputStream iis = ImageIO.createImageInputStream(new FileInputStream(src));
        reader.setInput(iis, true);

        ImageReadParam param = reader.getDefaultReadParam();
        Rectangle rect = new Rectangle(x, y, w, h);
        param.setSourceRegion(rect);
        BufferedImage bi = reader.read(0, param);

        ImageIO.write(bi, "jpg", dest);
    }

    public static void cutImageNative(String src, String dest, int x, int y, int w, int h) throws IOException {
        try {
            BufferedImage image = ImageIO.read(new File(src));
            BufferedImage crop = image.getSubimage(x, y, w, h);
            ImageIO.write(crop, "jpg", new File(dest));
        } catch (Exception e) {
            throw new RuntimeException(src + ":" + x + "," + y + "," + w + "," + h + " crop error", e);
        }
    }

    public static void main(String[] args) throws IOException {
        Pattern pattern = Pattern.compile("(\\d+).jpg");
        File input = new File("/Users/luoshi/Downloads/zt/853");
        File output = new File("/Users/luoshi/Downloads/zt/853-1");

        for (File file : input.listFiles()) {
            if (file.isFile()) {
                Matcher m = pattern.matcher(file.getName());
                if (m.matches()) {
                    String examNumber = m.group(1);
                    cutImage(file, new File(output, examNumber + "-7.jpg"), 150, 470, 1000, 1000);
                }
            }
        }
    }

}
