package com.qmth.test.image.utils;

import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.RequestEntity;
import org.apache.commons.httpclient.methods.StringRequestEntity;
import org.apache.commons.lang3.StringUtils;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

public class GxStudentApiClient {

    private String host;

    private String username;

    private String password;

    public GxStudentApiClient(String host, String username, String password) {
        this.host = host;
        this.username = username;
        this.password = password;
    }

    public JSONArray list(int examId, Boolean upload, Boolean absent, Integer pageNumber, Integer pageSize)
            throws HttpException, IOException {
        HttpClient client = new HttpClient();
        List<String> params = new LinkedList<String>();
        if (upload != null) {
            params.add("upload=" + upload.toString());
        }
        if (absent != null) {
            params.add("absent=" + absent.toString());
        }
        if (pageNumber != null) {
            params.add("pageNumber=" + pageNumber.toString());
        }
        if (pageSize != null) {
            params.add("pageSize=" + pageSize.toString());
        }
        String param = "";
        if (!params.isEmpty()) {
            param = "?" + StringUtils.join(params, "&");
        }
        GetMethod method = new GetMethod("http://" + host + "/api/students/" + examId + param);
        method.addRequestHeader("auth-info", "loginname=" + username + ";password=" + password);

        int code = client.executeMethod(method);
        if (code == 200) {
            String r = new String(method.getResponseBody(), "utf-8");
            return JSONArray.fromObject(r);
        } else {
            return null;
        }
    }

    public boolean upload(int examId, String examNumber, int sliceCount, int sheetCount, boolean absent, String answers,
            String batchCode) throws HttpException, IOException {
        HttpClient client = new HttpClient();
        PostMethod method = new PostMethod("http://" + host + "/api/scan/student/" + examId);
        method.addRequestHeader("auth-info", "loginname=" + username + ";password=" + password);

        JSONArray array = new JSONArray();
        JSONObject obj = new JSONObject();
        obj.accumulate("examNumber", examNumber);
        obj.accumulate("sliceCount", sliceCount);
        obj.accumulate("sheetCount", sheetCount);
        obj.accumulate("absent", absent);
        obj.accumulate("answers", answers);
        obj.accumulate("batchCode", batchCode);
        array.add(obj);

        RequestEntity entity = new StringRequestEntity(array.toString(), "application/json", "utf-8");
        method.setRequestEntity(entity);
        int code = client.executeMethod(method);
        if (code == 200) {
            String r = new String(method.getResponseBody(), "utf-8");
            JSONArray a = JSONArray.fromObject(r);
            return a != null && a.size() == 1;
        } else {
            return false;
        }
    }
}
